using J4L.RReport;
using System;
using System.IO;
using System.Drawing;
using System.Windows.Forms;


public class examplePDFOrder: RAreaListener
{

 int total=0;

	// entry point	
public static void Main(string[] args)
{	
        examplePDFOrder f=new examplePDFOrder();

		f.init();
}
 	

 // data arrays
public static String[] columnsNames = {"Article",
                        "Description","Priority",
                        "Quantity","Price"};

public static Object[,] columnsData = {
    {"A0301", "Printer XXX", "0",(Int32) 300,(Double) 30.9 },
    {"B0301", "CD-ROM writer","2", (Int32) 200,(Double) 3.0},
    {"C0405", "Laptop SP","1", (Int32) 330,(Double) 4500.9},
	{"D1001", "Mouse 45","0", (Int32) 100,(Double) 23.08},
    {"E3044", "Keyboard Ms 250","0", (Int32) 300,(Double) 223.901},
    {"F9902", "Mouse PS2","0", (Int32) 1300,(Double) 34},
    {"G2387", "Laser printer LP300","0", (Int32) 3200,(Double) 56.09},
	{"H0993", "Laser printer LP200","1", (Int32) 200,(Double) 3.93}};

 public void init() {

         // load report from file
		Report report=new Report();

        Console.WriteLine("loading report");
 		if (!report.importReport("examples\\PDF_DHTML\\order.rep")) {
 			Console.WriteLine("Error, could not load file");
 		}

		report.getAreaByName("Detail").setListener(this);
		// set the values for the header programatically
		report.getReportHeader().getItemByName("Number").setruntimeValue("111");
		report.getReportHeader().getItemByName("Date").setruntimeValue("10/10/2000");
		report.getReportHeader().getItemByName("Company").setruntimeValue("COMPANY PLC");
		report.getReportHeader().getItemByName("City").setruntimeValue("London");
		report.getReportHeader().getItemByName("address").setruntimeValue("Street 2");

		// we use the Array as data source
		report.getAreaByName("Detail").setDataSource(new RArraySource(columnsNames,columnsData));

		// set listener to calculate amounts on the fly
		report.getReportFooter().setListener(this);

        exportPDF(report);
        exportDHTML(report);

		Application.Exit();
 }

  private void exportPDF(Report rep) {

                //rep.setPDFFile("report.pdf"); // set pdf file
                rep.disablePrinting(true);
         		rep.prepare();
                Console.WriteLine("finishing report");
		        rep.endReport();
                Console.WriteLine("File exported: REPORT.PDF");
  				rep.exportPDF("report.pdf");
 }


  private void exportDHTML(Report rep) {


                
                rep.setDHTMLActive(true); // use dhtml instead of html

                rep.disablePrinting(true);

         		rep.prepare();

                Console.WriteLine("finishing report");

		        rep.endReport();

                Console.WriteLine("Writing to html file");

                // get dthml output
                String htmlString= rep.getHTML();
                   
     			try {
          			StreamWriter out2= new StreamWriter("report.html");
    	  			out2.Write(htmlString);
	      			out2.Close();
				} catch (Exception e) {
       		 		Console.WriteLine(e.Message);
    			}                    

            	Console.WriteLine("File exported: REPORT.HTML");

 }


 public void beforePrintingArea(RArea area) {

   // calculate the amount	of each line
	 if (area.getName().CompareTo("Detail")==0) {
		 double price=(Double) area.getItemByName("Price").getruntimeValue();
		 int quantity=(Int32) area.getItemByName("Quantity").getruntimeValue();
		 total=(Int32) (total+(quantity*price));
		 area.getItemByName("Amount").setruntimeValue( (Int32) quantity*price); 
	 }

   // set total amount
	 if (area.getName().CompareTo("Footer")==0) {
		 area.getItemByName("Total").setruntimeValue((Int32) total);
		 total=0;
	 }

 }



}
